/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of LRC.xs. Do not edit this file, edit LRC.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "LRC.xs"
/*
 * Perl Extension for LRC computations
 * Author...: Ralph Padron (whoelse@elitedigital.net)
 * Revised..: 01-May-2002
 *
 * The Longitudinal Redundancy Check (LRC) is a one byte character,
 * commonly used as a field in data transmission over analog systems.
 * 
 * Most commonly, in STX-ETX bounded strings sent in financial protocols.
 *
 * Following some previous experience with such protocols, I wrote
 * an LRC function in perl and later decided to re-write in C 
 * for efficiency.  The result is this module String::LRC
 * 
 * NOTE:
 *	Included sv_type comparison and lrcinit in v1.01 
 *	following the idea by Soenke J. Peters and others 
 *	that someone perhaps can use the LRC of a file.
 *
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/*
# * In String-LRC v1.00, I ran this in perl simply by doing
# * the XOR like this.
# * 
# * my $buffer = shift(@_);
# * my @str = split(//,$buffer);
# * my $len = 0;
# * $len = length($buffer) if ($buffer);
# * my ($i, $check);
# * for ($i = 0;$i < $len ; $i++) {
# *	$check = $check ^ $str[$i];
# * }# for
# * return $check;
# *
# *
 */

/* getlrc(...)
 * generate the lrc using the XOR of each byte
 *
 * ALTERNATIVE:
 * generate the lrc using a unsigned char sum of each ptr 
 * position in the string, and then take the two's complment.
 * My OS professor from college would kill me, but I have to admit, I'm 
 * not sure if the XOR and this alternative are actually equivalent.
 *
 */ 
unsigned char 
getlrc(unsigned char *string, unsigned long stringSize, unsigned char lrcinit)
{
  unsigned long i;
  unsigned char lrc  = lrcinit;
  unsigned char *buf = (unsigned char *) string;
  for (i=0; i < stringSize;  i++)
	lrc = lrc ^ buf[i];
  return (unsigned char) lrc; 
} // getlrc

unsigned char getlrc_fp(PerlIO *fp,unsigned char lrcinit)
{
    unsigned char lrc = lrcinit;
    int c;
    while( (c=PerlIO_getc(fp)) != EOF ) {
        lrc = lrc ^ c;
    }
    return (unsigned char) lrc;		// normal return of lrc byte
}

svtype getsvtype(SV *sv)
{
  if (sv == NULL )
    return SVt_NULL;
  if (SvROK(sv))
    return SvTYPE(SvRV(sv));
  else 
    return SvTYPE(sv);
}


#line 98 "LRC.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 242 "LRC.c"

XS_EUPXS(XS_String__LRC_lrc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_String__LRC_lrc)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "data, ...");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	data;
#line 98 "LRC.xs"
    unsigned char lrcinit = 0x00;
    STRLEN data_len;
#line 257 "LRC.c"
	unsigned char	RETVAL;
	dXSTARG;
#line 101 "LRC.xs"
	int sv_type;
	IO *io;
	SV *sv;
	unsigned char rv;
      {
	if ( items > 1 )
		lrcinit = (unsigned char) SvNV(ST(items - 1));

	sv_type = getsvtype(ST(0));

	if (sv_type == SVt_PVGV)
	  {
		io = sv_2io(ST(0));
		rv = (unsigned char) getlrc_fp(IoIFP(io), lrcinit);
	  }
	else
	  {
		data = (char *)SvPV(ST(0),data_len);
		rv = (unsigned char) getlrc(data, data_len, lrcinit);
	  }
	EXTEND(sp, 1);
	sv = newSV(0);
	//sv_setuv(sv, (UV)rv);
	sv_setpvn(sv, (char *)&rv, 1);
	PUSHs(sv_2mortal(sv));
      }
#line 287 "LRC.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_String__LRC); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_String__LRC)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5) && defined(XS_APIVERSION_BOOTCHECK)
  XS_APIVERSION_BOOTCHECK;
#endif

        newXS_deffile("String::LRC::lrc", XS_String__LRC_lrc);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

